#!/usr/bin/env node
import t from "chalk";
import { execSync as w } from "node:child_process";
import g, { resolve as E } from "node:path";
import l, { existsSync as N, rmSync as y } from "node:fs";
import n from "prompts";
import { getConfigPath as S, batchHandler as F } from "@done-coding/cli-template";
import { lookForParentTarget as I } from "@done-coding/node-tools";
import L from "yargs";
import { hideBin as O } from "yargs/helpers";
const P = "git@gitee.com:justsosu/done-coding-cli-config-json.git", C = "自定义模版路径", U = "./.create-done-coding_temp", p = {
  version: "0.5.2",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
};
let h;
const _ = async () => (h || (h = (await A()).templateList), h), $ = async () => [...await _(), { name: C }], j = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  validate: (e) => e.trim().length > 0 || "项目名称不能为空"
}, R = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await $()).map((o) => ({
    title: o.name,
    value: o.name
  }))
}), H = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, T = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), A = async () => {
  console.log(t.blue("拉取模板列表，请稍等..."));
  const e = g.resolve(
    process.cwd(),
    U
  );
  if (console.log(t.blue(`配置临时目录：${e}`)), l.existsSync(e)) {
    const i = `${e}目录已存在，是否删除？`, { isRemove: r } = await n(T(i));
    r ? l.rmSync(e, { recursive: !0, force: !0 }) : (console.log(t.red(`${e}已存在，请手动删除后再试！`)), process.exit(1));
  }
  w(`git clone ${P} ${e} --depth=1`);
  const o = p.name, c = g.resolve(e, `${o}.json`), f = JSON.parse(l.readFileSync(c, "utf-8"));
  if (!Array.isArray(f.templateList))
    throw new Error("远程配置文件出错，templateList 不是数组");
  return console.log(t.green("模板列表拉取成功！")), l.rmSync(e, { recursive: !0, force: !0 }), f;
}, G = async (e) => {
  const { projectName: o, template: c } = e, i = ((o ?? (await n(j)).projectName) || "").trim();
  if (!i.trim()) {
    console.log(t.red("项目名称不能为空"));
    return;
  }
  if (i.includes(" ") || i.includes("\\") || i.includes("/")) {
    console.log(t.red("项目名称不能包含空格或者\\或者/"));
    return;
  }
  const r = E(process.cwd(), i);
  if (N(r)) {
    const { isRemove: s } = await n(T());
    if (s === !0)
      y(r, { recursive: !0, force: !0 });
    else
      return console.log(t.red("项目已存在")), process.exit(1);
  }
  const m = c ?? (await n(await R())).template;
  let u = "";
  if (m === C) {
    const { customUrl: s } = await n({
      type: "text",
      name: "customUrl",
      message: "请输入自定义模板路径"
    });
    u = s;
  } else {
    const s = (await $()).find(
      (a) => a.name === m
    );
    if (!s)
      return console.log(t.red(`模板${m}不存在`)), process.exit(1);
    if (!s.url)
      return console.log(t.red(`模板${m}仓库地址不存在`)), process.exit(1);
    u = s.url;
  }
  const d = I(".git");
  console.log(t.green("正在初始化项目，请稍等...")), w(`git clone ${u} ${i} --depth=1`);
  const v = S(r);
  if (v) {
    await F({
      rootDir: r
    });
    const { isRemoveTemplateConfig: s } = await n({
      type: "confirm",
      name: "isRemoveTemplateConfig",
      message: `已成功将模板项目配置注入到当前项目，是否删除模板项目配置文件(${v})`
    });
    s && y(v, { force: !0 });
  }
  if (console.log(t.green("项目初始化完成")), d) {
    const s = g.resolve(r), a = g.resolve(s, ".git");
    if (!N(a))
      throw new Error("git目录不存在");
    const { isRemoveGit: b } = await n({
      type: "confirm",
      name: "isRemoveGit",
      message: `项目创建在父级git仓库${d}中，是否删除${i}目录下的.git(${a})`
    });
    b ? (y(a, { recursive: !0, force: !0 }), console.log(t.green("已删除当前项目git目录"))) : console.log(
      t.yellow(
        `项目创建在父级git仓库${d}中，请手动删除${i}目录下的.git(${a})，否则会影响后续的git操作`
      )
    );
  } else
    (await n(H)).saveGitHistory && (w(
      `cd ${r} && git remote rename origin upstream && git fetch --unshallow`
    ), console.log(
      t.green(
        "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
      )
    ), console.log(
      t.green("已保存git历史记录，后续可以与模板git仓库有完整的交互")
    ));
  console.log(
    t.blue(`
使用步骤: 
  1. cd ${i}
  2. pnpm install
  3. pnpm run dev
  `)
  );
}, M = async () => ({
  projectName: {
    type: "string",
    alias: "p",
    describe: j.message
  },
  template: {
    type: "string",
    alias: "t",
    choices: (await $()).map((e) => e.name),
    describe: (await R()).message
  }
}), x = p.cliConfig.moduleName, k = (e, o) => {
  console.log(e ? t.red(e) : t.red(o.message)), process.exit(1);
}, Y = p.description, B = `Usage: $0 ${x} [options]`, J = "Usage: $0 [options]", D = async (e, o) => {
  const c = await M();
  return e.strict().usage(o).help("help").version(p.version).alias("v", "version").alias("h", "help").options(c).fail(k).argv;
}, q = (e) => D(e, B), oe = {
  command: x,
  describe: Y,
  builder: q,
  handler: G
}, se = async () => {
  const e = L(O(process.argv)), o = await D(e, J);
  return G(o);
};
export {
  oe as a,
  se as c,
  G as h
};
